(function(){
  var ref$, filter, find, last, map, partition, reject, reverse, sortBy, clamp, findAll, partitionString, React, div, input, span, SimpleOption, SimpleValue;
  ref$ = require('prelude-ls'), filter = ref$.filter, find = ref$.find, last = ref$.last, map = ref$.map, partition = ref$.partition, reject = ref$.reject, reverse = ref$.reverse, sortBy = ref$.sortBy;
  ref$ = require('prelude-extension'), clamp = ref$.clamp, findAll = ref$.findAll, partitionString = ref$.partitionString;
  React = require('react'), ref$ = React.DOM, div = ref$.div, input = ref$.input, span = ref$.span;
  SimpleOption = require('./SimpleOption');
  SimpleValue = require('./SimpleValue');
  module.exports = React.createClass({
    displayName: 'ReactSelectize',
    getDefaultProps: function(){
      return {
        addOptions: false,
        disabled: false,
        onBlur: function(values){},
        onChange: function(values){},
        onOptionsChange: function(options){},
        optionClass: SimpleOption,
        options: [],
        restoreOnBackspace: false,
        style: {},
        valueClass: SimpleValue,
        values: []
      };
    },
    render: function(){
      var outOfOptions, showOptions, this$ = this;
      outOfOptions = !this.props.addOptions && this.props.values.length === this.props.options.length;
      showOptions = (function(){
        switch (false) {
        case !this.props.disabled:
          return false;
        case !!this.isBelowLimit():
          return false;
        case !outOfOptions:
          return false;
        default:
          return this.state.open;
        }
      }.call(this));
      return div({
        className: "multi-select " + (this.props.disabled ? 'disabled' : '') + " " + (showOptions ? 'open' : ''),
        style: this.props.style,
        onClick: function(){
          this$.setState({
            open: true
          });
          return this$.focus();
        }
      }, div({
        className: 'control',
        key: 'control'
      }, this.state.search.length === 0 && this.props.values.length === 0 ? div({
        className: 'placeholder'
      }, this.props.placeholder) : void 8, map(function(value){
        return React.createElement(this$.props.valueClass, import$({
          key: value,
          onRemoveClick: function(e){
            this$.removeValue(value);
            this$.clearAndFoucs();
            e.preventDefault();
            return e.stopPropagation();
          }
        }, find(function(it){
          return it.value === value;
        })(
        this$.props.options)) || {});
      })(
      this.props.values), input({
        disabled: this.props.disabled,
        ref: 'search',
        type: 'text',
        value: this.state.search,
        onChange: (function(){
          switch (false) {
          case !(this.isBelowLimit() && !outOfOptions):
            return function(arg$){
              var value, filteredOptions;
              value = arg$.currentTarget.value;
              filteredOptions = this$.filterOptions(value);
              return this$.setState({
                focusedOption: 0,
                open: filteredOptions.length > 0,
                search: value
              });
            };
          default:
            return function(){};
          }
        }.call(this)),
        onKeyDown: function(e){
          var ref$, label;
          switch (e.which) {
          case 9:
            this$.setState({
              open: false
            }, function(){
              return this$.props.onBlur(this$.props.values);
            });
            break;
          case 8:
            if (this$.state.search.length > 0) {
              return;
            }
            if ((ref$ = this$.removeValue(last(this$.props.values))) != null) {
              label = ref$.label;
            }
            if (!!label && !!this$.props.restoreOnBackspace) {
              this$.setState({
                focusedOption: 0,
                open: true,
                search: label
              });
            } else {
              this$.setState({
                open: false
              });
            }
            e.preventDefault();
            e.stopPropagation();
          }
          if (outOfOptions) {} else {
            switch (e.which) {
            case 13:
              this$.selectOption(this$.state.focusedOption);
              this$.setState({
                focusedOption: -1,
                open: false,
                search: ''
              });
              break;
            case 27:
              if (this$.state.open) {
                this$.setState({
                  open: false
                });
              } else {
                this$.reset();
              }
              this$.clearAndFoucs();
              break;
            case 38:
              this$.focusAdjacentOption(-1);
              break;
            case 40:
              this$.focusAdjacentOption(1);
              break;
            default:
              return;
            }
            e.preventDefault();
            return e.stopPropagation();
          }
        },
        style: {
          width: Math.max(16, this.state.search.length * 16)
        }
      }), div({
        className: 'reset',
        onClick: function(e){
          this$.reset();
          this$.clearAndFoucs();
          e.preventDefault();
          return e.stopPropagation();
        }
      }, '×'), div({
        className: 'arrow'
      }, null)), showOptions ? div({
        className: 'options'
      }, map(function(optionObject){
        var index, value, ref$;
        index = optionObject.index, value = optionObject.value;
        return div({
          ref: "option-" + index,
          key: value + "",
          onClick: function(e){
            this$.setState({
              open: false
            }, function(){
              this$.selectOption(index);
              return this$.clearAndFoucs();
            });
            e.preventDefault();
            return e.stopPropagation();
          },
          onMouseOver: function(){
            return this$.setState({
              focusedOption: index
            });
          },
          onMouseOut: function(){
            return this$.setState({
              focusedOption: -1
            });
          }
        }, React.createElement(this$.props.optionClass, (ref$ = import$({}, optionObject), ref$.addOptions = this$.props.addOptions, ref$.focused = index === this$.state.focusedOption, ref$)));
      })(
      this.filterOptions(this.state.search))) : void 8);
    },
    getInitialState: function(){
      return {
        focusedOption: 0,
        open: false,
        search: ''
      };
    },
    componentDidUpdate: function(){
      var optionElement, ref$, ref1$, parentElement, optionHeight;
      if (this.state.focusedOption === -1) {
        return;
      }
      if ((optionElement = this != null ? (ref$ = this.refs) != null ? (ref1$ = ref$["option-" + this.state.focusedOption]) != null ? ref1$.getDOMNode() : void 8 : void 8 : void 8) != null) {
        parentElement = optionElement.parentElement;
      }
      if (!optionElement) {
        return;
      }
      optionHeight = optionElement.offsetHeight - 1;
      if (optionElement.offsetTop - parentElement.scrollTop > parentElement.offsetHeight) {
        parentElement.scrollTop = optionElement.offsetTop - parentElement.offsetHeight + optionHeight;
      } else if (optionElement.offsetTop - parentElement.scrollTop + optionHeight < 0) {
        parentElement.scrollTop = optionElement.offsetTop;
      }
    },
    clearAndFoucs: function(){
      this.setState({
        search: ''
      });
      this.focus();
    },
    filterOptions: function(search){
      var ref$, addOptions, optionClass, options, values, result;
      ref$ = this.props, addOptions = ref$.addOptions, optionClass = ref$.optionClass, options = ref$.options, values = ref$.values;
      result = optionClass.filter(filter(function(arg$){
        var value;
        value = arg$.value;
        return !in$(value, values);
      })(
      options), search, {
        addOptions: addOptions
      });
      return map(function(index){
        var ref$;
        return ref$ = result[index], ref$.index = index, ref$;
      })(
      (function(){
        var i$, to$, results$ = [];
        for (i$ = 0, to$ = result.length; i$ < to$; ++i$) {
          results$.push(i$);
        }
        return results$;
      }()));
    },
    focus: function(){
      this.refs.search.getDOMNode().focus();
    },
    focusAdjacentOption: function(direction){
      this.setState({
        focusedOption: clamp(this.state.focusedOption + direction, 0, this.filterOptions(this.state.search).length - 1),
        open: true
      });
    },
    isBelowLimit: function(props){
      var ref$, maxItems, values;
      if ((ref$ = props || this.props) != null) {
        maxItems = ref$.maxItems, values = ref$.values;
      }
      return typeof maxItems === 'undefined' || values.length < maxItems;
    },
    removeValue: function(value){
      var option, newOption;
      if ((option = find(function(it){
        return it.value === value;
      })(
      this.props.options)) != null) {
        newOption = option.newOption;
      }
      if (!!newOption) {
        this.props.onOptionsChange(reject(function(it){
          return it.value === value;
        })(
        this.props.options));
      }
      this.props.onChange(reject((function(it){
        return it === value;
      }))(
      this.props.values));
      return option;
    },
    reset: function(){
      this.props.onChange([]);
    },
    selectOption: function(index){
      var filteredOptions, option, newOption, value;
      filteredOptions = this.filterOptions(this.state.search);
      if ((option = filteredOptions != null ? filteredOptions[index] : void 8) != null) {
        newOption = option.newOption, value = option.value;
      }
      if (!!newOption) {
        this.props.onOptionsChange([option].concat(this.props.options));
      }
      if (!!value) {
        this.props.onChange(this.props.values.concat(value));
      }
    }
  });
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
}).call(this);
